package model

import (
	"electricity_bill_calc/types"
	_ "github.com/shopspring/decimal"
	"time"
)

type SynchronizeConfiguration struct {
	User                   string    `json:"user" db:"user_id"`
	Park                   string    `json:"park" db:"park_id"`
	MeterReadingType       int16     `json:"meter_reading_type"`
	ImrsType               string    `json:"imrs_type"`
	AuthorizationAccount   string    `json:"authorization_account" db:"imrs_authorization_account"`
	AuthorizationSecret    string    `json:"authorization_secret" db:"imrs_authorization_secret"`
	AuthorizationKey       []byte    `json:"authorization_key,omitempty" db:"imrs_authorization_key"`
	Interval               int16     `json:"interval"`
	CollectAt              time.Time `json:"collect_at" db:"-"`
	MaxRetries             int16     `json:"max_retries"`
	RetryInterval          int16     `json:"retry_interval"`
	RetryIntervalAlgorithm int16     `json:"retry_interval_algorithm"`
}

type SynchronizeSchedule struct {
	User               string         `json:"userId" db:"user_id"`
	UserName           string         `json:"userName" db:"user_name"`
	Park               string         `json:"parkId" db:"park_id"`
	ParkName           string         `json:"parkName" db:"park_name"`
	TaskIdentity       string         `json:"taskIdentity" db:"task_identity"`
	TaskName           string         `json:"taskName" db:"task_name"`
	TaskDescription    string         `json:"taskDescription" db:"task_description"`
	CreatedAt          types.DateTime `json:"createdAt" db:"created_at"`
	LastModifiedAt     types.DateTime `json:"lastModifiedAt" db:"last_modified_at"`
	LastDispatchedAt   types.DateTime `json:"lastDispatchedAt" db:"last_dispatched_at"`
	LastDispatchStatus int16          `json:"lastDispatchStatus" db:"last_dispatch_status"`
	NextDispatchAt     types.DateTime `json:"nextDispatchAt" db:"next_dispatch_at"`
	CurrentRetries     int16          `json:"currentRetries" db:"current_retries"`
}
